VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SampleDriver"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private CallingApp As String
Private mFilename As String
Public Function SetClock(Enable As Boolean) As Boolean
 'Hardware-Debug-Funktion: Leitung "Clock" ein- (Enable=True) bzw. ausschalten (Enable=False)
 'Diese Funktion muss natrlich nur implementiert werden, wo es Sinn macht
End Function
Public Function SetOE(Enable As Boolean) As Boolean
 'Hardware-Debug-Funktion: Leitung "Output Enable" ein- (Enable=True) bzw. ausschalten (Enable=False)
 'Diese Funktion muss natrlich nur implementiert werden, wo es Sinn macht
End Function
Public Function SetStrobe(Enable As Boolean) As Boolean
 'Hardware-Debug-Funktion: Leitung "Strobe" ein- (Enable=True) bzw. ausschalten (Enable=False)
 'Diese Funktion muss natrlich nur implementiert werden, wo es Sinn macht
End Function
Public Function SetData(DataBit As Byte, Enable As Boolean) As Boolean
 'Hardware-Debug-Funktion: Datenleitung Nr. <DataBit> ein- (Enable=True) bzw. ausschalten (Enable=False)
 'Diese Funktion muss natrlich nur implementiert werden, wo es Sinn macht
End Function
Public Function PluginName() As String
 'Liefert den Pluginnamen zurck, den der BPE anzeigt
 PluginName = "Sample Plugin"
End Function

Public Function GetDisplayWidth() As Long
 'Liefert die Breite des Displays zurck
 GetDisplayWidth = 26
End Function

Public Function GetDisplayHeight() As Long
 'Liefert die Hhe des Displays zurck
 GetDisplayHeight = 20
End Function

Public Function OutputToDevice(OutputData() As Byte, ColorDepth As Byte, SizeX As Long, SizeY As Long) As Boolean
 ' Wird jedes mal aufgerufen, wenn ein neuer Frame ausgegeben werden soll
 ' OutputData: Byte-Array, das die einzelnen Pixel-Werte enthlt. Auslesen z.B per OutputData(X, Y)
 ' ColorDepth: Enthlt die Anzahl der Bits fr die Farbtiefe
 ' SizeX: Anzahl der Pixel in OutputData fr die Breite
 ' SizeY: Anzahl der Pixel in OutputData fr die Hhe
  
 'Diese Beispielfunktion wrde alle Pixel im Direktfenster ausgeben, die mehr als halb so hell leuchten, wie maximal mglich.
 Dim MaxVal As Byte, Colr As Byte, X As Byte, Y As Byte
 
 MaxVal = 2 ^ ColorDepth - 1
 Colr = (MaxVal / 2) + 0.5
 For Y = 1 To SizeY
  For X = 1 To SizeX
   If OutputData(X, Y) >= Colr Then
    Debug.Print "1";
   Else
    Debug.Print "0";
   End If
  Next X
  Debug.Print
 Next Y
 OutputToDevice = True
End Function

Public Function Configure() As Boolean
 'Diese Funktion wird aufgerufen, wenn der Benutzer die Plugineinstellungen ndern mchte.
 'Hier knnen Sie z.B. das Einstellungsformular anzeigen lassen:
 frmConfig.Show 1
 'Oder einfach einen Hinweis ausgeben:
 'MsgBox "Keine weiteren Einstellungen ntig.", vbInformation
 Configure = True
End Function

Public Function Init(CallingAppTitle As String, MyFilename As String) As Boolean
 'Wird beim Start des Plugins ausgefhrt.
  
 CallingApp = CallingAppTitle
 mFilename = MyFilename
 
 Einstellung = GetSetting(CallingApp, "Plugins\" & mFilename, "MeineEinstellung", "Hallo!")

 Init = True
End Function

Public Function Term() As Boolean
 'Wird beim Beenden des Plugins ausgefhrt
 
 SaveSetting CallingApp, "Plugins\" & mFilename, "MeineEinstellung", Einstellung
 
 Term = True
End Function

